//SELLING COMMANDER FRONT
(function ____(fn) {
  if (document.readyState != 'loading'){
    fn();
  } else if (document.addEventListener) {
    document.addEventListener('DOMContentLoaded', fn);
  } else {
    document.attachEvent('onreadystatechange', function() {
      if (document.readyState != 'loading')
        fn();
    });
  }
})(function(){

   if(typeof sc_b2b === 'undefined')
    return;

   let doEntryCall = function(data, success, fail){
    var xhttp = new XMLHttpRequest();
    xhttp.open("POST", sc_b2b.enter_b2b_url , true);
    xhttp.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    xhttp.onreadystatechange = function() {
     if (this.readyState == 4 && this.status == 200) {
	   try{	 
		   var response = JSON.parse(this.responseText);
		   success(response);
	   }catch(ex){
		   if(fail)
				fail();
	   }
     }else if(this.status != 200){
       if(fail)
         fail();
     }
    };
	let formData = [];
	if(data){
		for(let prop in data){
			if(data.hasOwnProperty(prop)){
				formData.push(prop + "=" + encodeURIComponent(data[prop]));
			}
		}
	}
    xhttp.send(formData.join("&"));
   };

   if(/\[sc\_enter\_b2b\]/.test(document.body.innerHTML)){
     let xpathres = document.evaluate("//*[contains(text(), '[sc_enter_b2b]')]",document, null, XPathResult.ANY_TYPE, null );
     let el =  xpathres.iterateNext();
     let sc_nodes = [];
     while (el) {
       if(sc_nodes.length){
         if(el.parentNode === sc_nodes[sc_nodes.length - 1]){
           sc_nodes.splice(sc_nodes.length - 1,1);
         }
       }
       sc_nodes.push(el);
       el = xpathres.iterateNext();
     }

     for(let i = 0; i < sc_nodes.length;i++){
       try{
         sc_nodes[i].innerHTML =  sc_nodes[i].innerHTML.replace(/\[sc\_enter\_b2b\]/g,"<scb2bpanel></scb2bpanel>");
       }catch(ex){
         //
       }
     }

     if(document.getElementsByTagName("scb2bpanel")[0]){
        if(sc_b2b.needs_login){

            let b2btags = document.getElementsByTagName("scb2bpanel");

            let p = document.createElement("p");
            p.innerHTML = sc_b2b.b2b_login_message || "";
            p.className = "sc_login_message";
            b2btags[0].appendChild(p);

            p = document.createElement("p");
            let username_inp = document.createElement("input");
            username_inp.setAttribute("type","text");
            username_inp.className = "sc_username_or_email";
            p.appendChild(username_inp);
            p.setAttribute("label",sc_b2b.LABELS.username + "/" + sc_b2b.LABELS.email);

            b2btags[0].appendChild(p);
            p = document.createElement("p");
            let password_inp = document.createElement("input");
            password_inp.setAttribute("type","password");
            password_inp.className = 'sc_password';
            p.appendChild(password_inp);
            p.setAttribute("label",sc_b2b.LABELS.password);
            b2btags[0].appendChild(p);

            p = document.createElement("p");
            let forgot_a = document.createElement("a");
            forgot_a.className = "sc_forgot";
            forgot_a.setAttribute("href",sc_b2b.base_url + "/index.php?option=com_users&view=reset");
            forgot_a.innerHTML = sc_b2b.LABELS.forgot;
            p.appendChild(forgot_a);
            b2btags[0].appendChild(p);

            let p_msg = document.createElement("p");
            b2btags[0].appendChild(p_msg);

            p = document.createElement("p");
            let cmd = document.createElement("button");
            cmd.className = "sc_login_btn";
            cmd.innerHTML = sc_b2b.LABELS.login;
            p.appendChild(cmd);
            b2btags[0].appendChild(p);

            for(let i = 1; i < b2btags.length; i++){
              b2btags[i].innerHTML = b2btags[0].innerHTML;
            }

            cmd.onclick = function(e){
              cmd.setAttribute('disabled','disabled');

              doEntryCall({username:username_inp.value, password: password_inp.value },
                function(response){
                  if(response.url){
					let url = response.url;
				    if(response.access_token){
						url = url + (url.indexOf("?") > -1 ? "&" : "?")  + ("sc_direct_user_token=" + encodeURIComponent(response.access_token));
					} 
					window.location.href = url;
					return;
                  }else if(response.error){
                    p_msg.innerHTML = response.error;
                    p_msg.style.color = 'red';
                  }else if(response.message){
                    p_msg.innerHTML = response.message;
                    p_msg.style.color = '';
                  }

                  for(let i = 1; i < b2btags.length; i++){
                    b2btags[i].innerHTML = b2btags[0].innerHTML;
                  }
				  
				   cmd.removeAttribute('disabled');
                },
                function(){
                    cmd.removeAttribute('disabled');
					
                });
            };
        }else{
            if(!sc_b2b.b2b_has_access){
              let b2btags = document.getElementsByTagName("scb2bpanel");
              for(let i = 0; i < b2btags.length; i++){
                b2btags[i].innerHTML = "<p class='sc-b2b-error' style='color:red;'>" + sc_b2b.b2b_no_access_message + "</p>";
              }
            }else{
              doEntryCall({referrer: window.location.href},
                function(response){
				  let b2btags = document.getElementsByTagName("scb2bpanel");
				  
                  if(response.url){
                    let url = response.url;
				    if(response.access_token){
						url = url + (url.indexOf("?") > -1 ? "&" : "?")  + ("sc_direct_user_token=" + encodeURIComponent(response.access_token));
					} 
					window.location.href = url;
					return;
                  }else if(response.error){
					for(let i = 0; i < b2btags.length; i++){
						b2btags[i].innerHTML = "<p class='sc-b2b-error' style='color:red;'>" + response.error + "</p>";
					}
				  }else if(response.message){
                    for(let i = 0; i < b2btags.length; i++){
						b2btags[i].innerHTML = "<p class='sc-b2b-message' style='color:red;'>" + response.message + "</p>";
					}
                  }
                },
                function(){
					let b2btags = document.getElementsByTagName("scb2bpanel");
				    for(let i = 0; i < b2btags.length; i++){
						b2btags[i].innerHTML = "<p class='sc-b2b-error' style='color:red;'>B2B ACCESS ERROR</p>";
				    }
                });
            }
        }
     }
   }

   if(sc_b2b.b2b_has_access && sc_b2b.b2b_ordering_force){
     document.addEventListener("click",function(event) {


        if(!sc_b2b.b2b_ordering_force)
          return;

        if (event===undefined)
          event= window.event;

        var target= 'target' in event ? event.target : event.srcElement;
        try{
          if(target){
            if(target.name == "addtocart"){
              if(target.form){

                let inputs  = target.form.getElementsByTagName("INPUT");
                let selects = target.form.getElementsByTagName("SELECT");
                let tarears = target.form.getElementsByTagName("TEXTAREA");

                let formDataElements = [];

                for(let i = 0 ; i < tarears.length;i++){
                  if(tarears[i].name){
                    formDataElements.push(tarears[i]);
                  }
                }

                for(let i = 0 ; i < selects.length;i++){
                  if(selects[i].name){
                    formDataElements.push(selects[i]);
                  }
                }

                for(let i = 0 ; i < inputs.length;i++){
                  if(inputs[i].name && inputs[i].type != "submit"){
                    if(inputs[i].type == "checkbox" || inputs[i].type == "radio"){
                      if(inputs[i].checked){
                        formDataElements.push(inputs[i]);
                      }
                    }else
                      formDataElements.push(inputs[i]);
                  }
                }

                let d = {};
                for(let i = 0 ; i < formDataElements.length;i++){
                  d[formDataElements[i].name] = formDataElements[i].value;
                }

                if(d["virtuemart_product_id[]"] || d["virtuemart_product_id"]){


                  let doorder = {
                    p: d["virtuemart_product_id[]"] || d["virtuemart_product_id"],
                    q: d["quantity[]"] || d["quantity"] || 1,
                  };

                  for(let prop in d){
                    if(d.hasOwnProperty(prop)){
                      if(prop.indexOf("customProductData[" + doorder.p + "][") > -1){
                        if(!doorder.a)
                          doorder.a = {};
                        doorder.a[ prop.replace("customProductData[" + doorder.p + "][","").replace("]","")] = d[prop];
                      }
                    }
                  }

                  doEntryCall({referrer: window.location.href},
                    function(response){
                      if(response.url){
					    let url = response.url + (response.url.indexOf("?") > -1 ? "&" : "?") + "doorder=" + encodeURIComponent(JSON.stringify( doorder ));
						if(response.access_token){
							url += ("&sc_direct_user_token=" + encodeURIComponent(response.access_token));
						} 
						window.location.href = url;
					    return;
                      } else {
                        sc_b2b.b2b_ordering_force = false;
                        target.click();
                      }
                    },
                    function(){
                        sc_b2b.b2b_ordering_force = false;
                        target.click();
                    });

                    event.preventDefault();
                    event.stopImmediatePropagation();
                }
              }
            }
          }
        }catch(cex){
          //
        }
     },true);
   }

});
