<?php
/**
 * @copyright	Copyright (C) 2015 Holest Engineering www.holest.com.
 * @license		GNU General Public License version 2 or later
 */
defined('_JEXEC') or die;
class PlgvmcustomsellingcommanderconnectorInstallerScript
{
	 public function install($parent)
	 {
	  // Enable plugin
	  $db = JFactory::getDBO();
	  $db->setQuery("UPDATE #__extensions SET enabled = 1 WHERE element LIKE 'sellingcommanderconnector'");
	  $db->execute();
	  
	  
	  $install_sql = file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "install.mysql.sql");
	  if($install_sql){
		  $install_sql = explode(";",$install_sql);
		  foreach($install_sql as $sql){
			if(trim($sql)){  
				$db->setQuery($sql);
				$db->execute();	
			}			
		  }
	  }
	  
	 }
	 
	 public function update($parent)
	 {
		$this->install($parent);
	 }
	 
	 public function uninstall(JAdapterInstance $adapter){
		$db = JFactory::getDBO();
		$uninstall_sql = file_get_contents(__DIR__ . DIRECTORY_SEPARATOR . "uninstall.mysql.sql");
		if($uninstall_sql){
		  $uninstall_sql = explode(";",$uninstall_sql);
		  foreach($uninstall_sql as $sql){
			if(trim($sql)){  
				$db->setQuery($sql);
				$db->execute();	
			}			
		  }
		}
	 }
}
?>